# sargo-temp

Temporary fixes that make Mobian work on sargo.

Please note that the MIT license does not apply to `qcom-firmware`.

## What to do

### Build Image

Instructions can be found in IMAGE.md in this repo.

### Flash image

First flash the image. Boot the phone.

Connect via SSH: `ssh mobian@10.66.0.1`

Accept the host key.

### Roll out workarounds using Ansible

You have to have `ansible-playbook` installed.

Go to the Ansible folder: `cd ansible`

Roll out workarounds: `./workarounds.sh`

Reboot phone via SSH.

Connect to wifi.

Rolling out the workarounds for audio requires installing packages from the repo, so we need an internet connection.

Roll out audio workarounds: `./audio.sh`

## Project Status

### This Works

- booting
- display
- touch
- modem
- plymouth
- battery/charging
- mobile data
- wifi
- torch
- suspend
- SMS (only receiving was tested, but I don’t have reason to believe sending wouldn’t work)
- call audio (partly, I still need to sort out how to get the built-in microphone working in calls, it already works outside of calls) 
- vibration
- audio (ALSA config not packaged, but can be manually added using the playbook in this repo)
- Bluetooth™
- eSIM
- camera (front camera buggy, back camera works but patches not in git yet)
- GPS (needs some improvements for better accuracy)

### This Does Not Work (Soon)

- USB host mode (need to verify whether that's still the case or whether it can be used now)
- full disk encryption (no installer images yet, once the other stuff is done this will magically be there)

### This Has An Unknown Status

- Fingerprint Sensor
- NFC (no idea what software I could use for testing, but should work, does so on pmOS)

### This Is Missing And Will Come Later

- accelerometer
- magnetometer
- ambient light sensor
- barometer

### The Main Issues To Solve

- A systemd unit with a hard-coded value, that has to be manually edited for now (`droid-juicer.service`)
  - https://gitlab.com/mobian1/droid-juicer/-/issues/4
- New release of qcom-phone-utils required so that my patches are available from the repo
  - https://salsa.debian.org/DebianOnMobile-team/qcom-phone-utils/-/commit/4f77281197c6ba1cfc1a82596157d00e8a7e014b
- ALSA config not yet packaged, has to be manually copied for now (the Playbook in this repo does that)
- A few things to do for kernel packaging and then submitting that to Mobian... or merge with patches for the qcom kernel somehow
  - patches are already being upstreamed by the sdm670-linux project, maybe that's already done before I start working on it xD
- no call audio yet, as the daemon (q6voiced) is not yet packaged (the Playbook in this repo compiles it and installs it)
- simple script that brings up Bluetooth has to be added somewhere (for now this repo contains a udev rule... but something is wrong with it. Run "/opt/bluetooth-mac.bash" to get Bluetooth working, repeat after reboots)
- udev rule for vibration has to be added to whatever package that is

### The Sources (Use The Source, Luke)

- My efforts of packaging a device-specific kernel: https://salsa.debian.org/erebion/sdm-670-linux (which will be used until all patches are part of upstream Linux and we can finally use a regular mainline kernel)
- `mobian-recipes`, which is used to build images: https://salsa.debian.org/Mobian-team/mobian-recipes
- `droid-juicer`, which retrieves some important files from some partitions: https://gitlab.com/mobian1/droid-juicer
- postmarketOS wiki: https://wiki.postmarketos.org (lovely folks, thanks for sharing everything you found out the hard way :D)

### Thanks For All The Fish

Huge thanks to be sdm670-linux project and flamingradian who runs the project (just one person!) to make sure the Kernel works on those devices! :)

I don’t know how Kernel development works, so I would have never started porting without this project.

Find that here: https://gitlab.com/sdm670-mainline/linux
